![Logo](./docs/junkie_logo_100x100.png)
[![GPLv3 License](https://img.shields.io/badge/License-GPL%20v3-yellow.svg)](https://opensource.org/licenses/GPL-3.0)

# [JuNkIE](https://bitbucket.org/rfg_lab/junkie/src/master/) (a JUpyter NotebooK Image Explorer)

## Installing [JuNkIE](https://bitbucket.org/rfg_lab/junkie/src/master/)

To install [JuNkIE](https://bitbucket.org/rfg_lab/junkie/src/master/), type:  

    $ python3 -m pip install --no-cache-dir -U junkie-rfglab

### A note on the Python interpreter

[JuNkIE](https://bitbucket.org/rfg_lab/junkie/src/master/) requires that you
have [Python 3.10 or above](https://www.python.org/downloads/) installed.

## Using [JuNkIE](https://bitbucket.org/rfg_lab/junkie/src/master/)

[JuNkIE](https://bitbucket.org/rfg_lab/junkie/src/master/) uses [matplotlib](https://matplotlib.org/) and [ipywidgets](https://ipywidgets.readthedocs.io/en/stable/), so there is some boiler plate code that you need before importing [JuNkIE](https://bitbucket.org/rfg_lab/junkie/src/master/):

```python
import matplotlib
%matplotlib widgets

from junkie import junkie
```

![Importing JuNkIE](./docs/import_junkie.gif)

There are a couple of ways to open an image with [JuNkIE](https://bitbucket.org/rfg_lab/junkie/src/master/):

- You can open an image with some other package (e.g. scikit-image, opencv, PIL, etc.) and invoke [JuNkIE](https://bitbucket.org/rfg_lab/junkie/src/master/) with a [numpy ndarray](https://numpy.org/doc/stable/reference/generated/numpy.ndarray.html) as the parameter:

![Opening an ndarray](./docs/open_ndarray.gif)

- You can also specifiy the path to the image that you want to open:

![Opening a file path](./docs/open_file.gif)

- Or you can indicate a folder that contains an image sequence:

![Opening a folder](./docs/open_folder.gif)

- If there are image channels split into different files, you can also specify a tuple of strings to distinguish which files in the folder belong to which channel:

![Opening mutiple channels from a folder](./docs/open_folder_multichannel.gif)

[JuNkIE](https://bitbucket.org/rfg_lab/junkie/src/master/) has a couple of additional parameters:

- *cmap* (str) indicates the color map used to display the image. It defaults to *'gray'*. Check [here](https://matplotlib.org/stable/tutorials/colors/colormaps.html) for a list of color maps.

![Color maps](./docs/colormaps.gif)

- *figsize* (Tuple[int, int]) specifies the image panel size. The image aspect ratio is maintained. It defaults to *(4, 4)*.

![Figure size](./docs/figsize.gif)

[JuNkIE](https://bitbucket.org/rfg_lab/junkie/src/master/) provides access to the standard [matplotlib](https://matplotlib.org/) toolbar, and also includes a new one with additional functionality:

![Toolbar](./docs/toolbar.gif)

## Citing [JuNkIE](https://bitbucket.org/rfg_lab/junkie/src/master/)

If you use [JuNkIE](https://bitbucket.org/rfg_lab/junkie/src/master/), please cite this repository. We are working on the paper!

## Sponsors

We are grateful for the generous support from the following agencies and institutions, which contribute to the
development and maintenance of [JuNkIE](https://bitbucket.org/rfg_lab/junkie/src/master/):

![Sponsors](./docs/sponsors.png)